Main Page | Modules | Class Hierarchy | Alphabetical List | Class List | File List | Class Members | Related Pages

# SoDragPointDragger Class Reference
[Draggers]

`#include <Inventor/draggers/SoDragPointDragger.h>`

Inheritance diagram for SoDragPointDragger:

List of all members.

## Detailed Description

The SoDragPointDragger class provides mechanisms for moving a point in 3D.

Here's how the dragger looks with it's default geometry in the inactive state:

This dragger is convenient to use when it is desirable that the end-user should interact with points by positioning them freely in 3D space.

The dragger consists of a part for 2D motion in a plane (like the SoTranslate2Dragger) and another part on the axis normal to the plane.

While the dragger is inactive (ie the user is not currently grabbing and / or dragging it's parts), the CTRL keys on the keyboard can be used to switch the orientation of the 2D-plane part and the normal-axis part so the normal-axis part points along one of the other principal axes. This is done by position the mouse pointer over the dragger geometry and pressing and releasing a CTRL key.

## Public Member Functions
| SoDragPointDragger (void)
void | setJumpLimit (const float limit)
float | getJumpLimit (void) const
void | showNextDraggerSet (void)
## Static Public Member Functions
void | initClass (void)
## Public Attributes
SoSFVec3f | translation
## Protected Member Functions
| ~SoDragPointDragger ()
virtual SbBool | setUpConnections (SbBool onoff, SbBool doitalways=FALSE)
virtual void | setDefaultOnNonWritingFields (void)
void | dragStart (void)
void | drag (void)
void | dragFinish (void)
## Static Protected Member Functions
void | startCB (void *f, SoDragger *d)
void | motionCB (void *f, SoDragger *d)
void | finishCB (void *f, SoDragger *d)
void | metaKeyChangeCB (void *f, SoDragger *d)
void | fieldSensorCB (void *f, SoSensor *s)
void | valueChangedCB (void *f, SoDragger *d)
## Protected Attributes
SoFieldSensor * | fieldSensor

## Constructor & Destructor Documentation

SoDragPointDragger::SoDragPointDragger | ( | void |  | ) |

| Default constructor, sets up the dragger nodekit catalog with the interaction and feedback geometry. Node kit structure (new entries versus parent class marked with arrow prefix):
      CLASS SoDragPointDragger
      -->"this"
            "callbackList"
            "topSeparator"
               "motionMatrix"
      -->      "noRotSep"
      -->         "xTranslatorSwitch"
      -->            "xTranslator"
      -->         "xyTranslatorSwitch"
      -->            "xyTranslator"
      -->      "rotXSep"
      -->         "rotX"
      -->         "xzTranslatorSwitch"
      -->            "xzTranslator"
      -->      "rotYSep"
      -->         "rotY"
      -->         "zTranslatorSwitch"
      -->            "zTranslator"
      -->         "yzTranslatorSwitch"
      -->            "yzTranslator"
      -->      "rotZSep"
      -->         "rotZ"
      -->         "yTranslatorSwitch"
      -->            "yTranslator"
      -->      "xFeedbackSwitch"
      -->         "xFeedbackSep"
      -->            "xFeedbackTranslation"
      -->            "xFeedback"
      -->      "yFeedbackSwitch"
      -->         "yFeedbackSep"
      -->            "yFeedbackTranslation"
      -->            "yFeedback"
      -->      "zFeedbackSwitch"
      -->         "zFeedbackSep"
      -->            "zFeedbackTranslation"
      -->            "zFeedback"
      -->      "planeFeedbackSep"
      -->         "planeFeedbackTranslation"
      -->         "planeFeedbackSwitch"
      -->            "yzFeedback"
      -->            "xzFeedback"
      -->            "xyFeedback"
               "geomSeparator"
(See SoBaseKit::printDiagram() for information about the output formatting.) Detailed information on catalog parts:
      CLASS SoDragPointDragger
      PVT   "this",  SoDragPointDragger  ---
            "callbackList",  SoNodeKitListPart [ SoCallback, SoEventCallback ]
      PVT   "topSeparator",  SoSeparator  ---
      PVT   "motionMatrix",  SoMatrixTransform  ---
      PVT   "noRotSep",  SoSeparator  ---
      PVT   "xTranslatorSwitch",  SoSwitch  ---
            "xTranslator",  SoTranslate1Dragger  ---
      PVT   "xyTranslatorSwitch",  SoSwitch  ---
            "xyTranslator",  SoTranslate2Dragger  ---
      PVT   "rotXSep",  SoSeparator  ---
      PVT   "rotX",  SoRotation  ---
      PVT   "xzTranslatorSwitch",  SoSwitch  ---
            "xzTranslator",  SoTranslate2Dragger  ---
      PVT   "rotYSep",  SoSeparator  ---
      PVT   "rotY",  SoRotation  ---
      PVT   "zTranslatorSwitch",  SoSwitch  ---
            "zTranslator",  SoTranslate1Dragger  ---
      PVT   "yzTranslatorSwitch",  SoSwitch  ---
            "yzTranslator",  SoTranslate2Dragger  ---
      PVT   "rotZSep",  SoSeparator  ---
      PVT   "rotZ",  SoRotation  ---
      PVT   "yTranslatorSwitch",  SoSwitch  ---
            "yTranslator",  SoTranslate1Dragger  ---
      PVT   "xFeedbackSwitch",  SoSwitch  ---
      PVT   "xFeedbackSep",  SoSeparator  ---
      PVT   "xFeedbackTranslation",  SoTranslation  ---
            "xFeedback",  SoSeparator  ---
      PVT   "yFeedbackSwitch",  SoSwitch  ---
      PVT   "yFeedbackSep",  SoSeparator  ---
      PVT   "yFeedbackTranslation",  SoTranslation  ---
            "yFeedback",  SoSeparator  ---
      PVT   "zFeedbackSwitch",  SoSwitch  ---
      PVT   "zFeedbackSep",  SoSeparator  ---
      PVT   "zFeedbackTranslation",  SoTranslation  ---
            "zFeedback",  SoSeparator  ---
      PVT   "planeFeedbackSep",  SoSeparator  ---
      PVT   "planeFeedbackTranslation",  SoTranslation  ---
      PVT   "planeFeedbackSwitch",  SoSwitch  ---
            "yzFeedback",  SoSeparator  ---
            "xzFeedback",  SoSeparator  ---
            "xyFeedback",  SoSeparator  ---
      PVT   "geomSeparator",  SoSeparator  ---
(See SoBaseKit::printTable() for information about the output formatting.)

SoDragPointDragger::~SoDragPointDragger | ( |  | ) | `[protected]`

| Protected destructor. (Dragger classes are derived from SoBase, so they are reference counted and automatically destroyed when their reference count goes to 0.)

## Member Function Documentation

void SoDragPointDragger::initClass | ( | void |  | ) | `[static]`

| Initializes type system for this dragger class. Application programmers should usually not have to invoke this method, see documentation of SoInteraction::init(). Reimplemented from SoDragger.

void SoDragPointDragger::setJumpLimit | ( | const float | limit | ) |

| The dragger plane jump limit is ignored in Coin, as we use a continuous moving plane. This method still included for API compatibility with the original SGI Inventor API.

float SoDragPointDragger::getJumpLimit | ( | void |  | ) | const

| The dragger plane jump limit is ignored in Coin, as we use a continuous moving plane. This method still included for API compatibility with the original SGI Inventor API.

void SoDragPointDragger::showNextDraggerSet | ( | void |  | ) |

| Circulate the dragger's three different sets of geometry, to circulate the orientation of the translation axis and translation plane through the three principal axes. This function is triggered when the user taps the `CTRL` key.

SbBool SoDragPointDragger::setUpConnections | ( | SbBool | onoff,
|  | SbBool | doitalways = FALSE
| ) | `[protected, virtual]`

| Sets up all internal connections for instances of this class. (This method will usually not be of interest to the application programmer, unless you want to extend the library with new custom nodekits or dragger classes. If so, see the SoBaseKit class documentation.) Reimplemented from SoInteractionKit.

void SoDragPointDragger::setDefaultOnNonWritingFields | ( | void |  | ) | `[protected, virtual]`

| (Be aware that this method is unlikely to be of interest to the application programmer who does not want to extend the library with new custom nodekits or draggers. If you indeed are writing extensions, see the information in the SoBaseKit class documentation.) This is a virtual method, and the code in it should call SoField::setDefault() with argument `TRUE` on part fields that should not be written upon scenegraph export operations. This is typically done when: field value is `NULL` and part is `NULL` by default it is a leaf SoGroup or SoSeparator node with no children it is a leaf listpart with no children and an SoGroup or SoSeparator container it is a non-leaf part and it's of SoGroup type and all fields are at their default values Subclasses should usually override this to do additional settings for new member fields. From the subclass, do remember to call "upwards" to your superclass' setDefaultOnNonWritingFields() method. Reimplemented from SoDragger.

void SoDragPointDragger::dragStart | ( | void |  | ) | `[protected]`

| This API member is considered internal to the library, as it is not likely to be of interest to the application programmer. Called when dragger is selected (picked) by the user.

void SoDragPointDragger::drag | ( | void |  | ) | `[protected]`

| This API member is considered internal to the library, as it is not likely to be of interest to the application programmer. Called when user drags the mouse after picking the dragger.

void SoDragPointDragger::dragFinish | ( | void |  | ) | `[protected]`

| This API member is considered internal to the library, as it is not likely to be of interest to the application programmer. Called when mouse button is released after picking and interacting with the dragger.

void SoDragPointDragger::startCB | ( | void * | d,
|  | SoDragger * | d
| ) | `[static, protected]`

| This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

void SoDragPointDragger::motionCB | ( | void * | d,
|  | SoDragger * | d
| ) | `[static, protected]`

| This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

void SoDragPointDragger::finishCB | ( | void * | d,
|  | SoDragger * | d
| ) | `[static, protected]`

| This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

void SoDragPointDragger::metaKeyChangeCB | ( | void * | d,
|  | SoDragger * | d
| ) | `[static, protected]`

| This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

void SoDragPointDragger::fieldSensorCB | ( | void * | d,
|  | SoSensor * | s
| ) | `[static, protected]`

| This API member is considered internal to the library, as it is not likely to be of interest to the application programmer. Reimplemented from SoInteractionKit.

void SoDragPointDragger::valueChangedCB | ( | void * | f,
|  | SoDragger * | d
| ) | `[static, protected]`

| This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

## Member Data Documentation

SoSFVec3f SoDragPointDragger::translation

| Continuously updated to contain the current translation from the dragger's local origo position. The application programmer applying this dragger in his code should connect the relevant node fields in the scene to this field to make it follow the dragger.

SoFieldSensor * SoDragPointDragger::fieldSensor`[protected]`

| This API member is considered internal to the library, as it is not likely to be of interest to the application programmer. Reimplemented from SoInteractionKit.

The documentation for this class was generated from the following files:

- SoDragPointDragger.h
- SoDragPointDragger.cpp